"use strict";
class IterableObject {
    [Symbol.iterator]() {
        let key = 0;
        return {
            next: () => {
                let result;
                if (this.valid(key)) {
                    result = {
                        value: this.current(key),
                        done: false
                    };
                    key = this.next(key);
                }
                else {
                    result = {
                        done: true
                    };
                }
                return result;
            }
        };
    }
    next(key) {
        return key + 1;
    }
}
exports.Iterable = IterableObject;
